#ifndef __QUATERNION_H__
#define __QUATERNION_H__

#include <OrbiterAPI.h>

class Quaternion
{
	double a,b,c,d;
public:
	Quaternion();
	Quaternion(VECTOR3, double);
	Quaternion(double, double, double, double);
	~Quaternion();
	
	Quaternion& operator=(const Quaternion& arg);
	Quaternion operator*(const Quaternion& arg);
	
	VECTOR3 rotationAxis();
	double rotationAngle();
	
	Quaternion conj();
	Quaternion inv();
	
	VECTOR3 transform(VECTOR3);
};

Quaternion fromEuler(double, double, double);

#endif
