#include "orbitersdk.h"

HINSTANCE g_hDLL;

class pv_s6 : public VESSEL3
{

public:
	pv_s6(OBJHANDLE hObj, int fmodel);
	~pv_s6();

	UINT uMeshIdx;
	MESHHANDLE hMesh;

	void DefineAnimations();
	void clbkSetClassCaps(FILEHANDLE cfg);
	void clbkPostStep(double simt, double simdt, double mjd);
	int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);
	void clbkSaveState(FILEHANDLE scn);
	void clbkLoadStateEx(FILEHANDLE scn, void *status);
	AnimState::Action GetAction(int a);

	bool clbkDrawHUD(int mode, const HUDPAINTSPEC *hps,oapi::Sketchpad *skp);

	ATTACHMENTHANDLE aBay, aGrTop, aGrBottom, aS5;


	bool topTracking;
	bool bottomTracking;
	double topArrayTgt, bottomArrayTgt;
	double arrayRotRate;
	double topArrayRot, bottomArrayRot;

	void OperateBottomAssembly(bool open);
	void OperateTopAssembly(bool open);
	void OperateRadiator(bool open);

	static bool clbkTopArrayTgt(void *id, char *str, void *usrdata);
	static bool clbkBottomArrayTgt(void *id, char *str, void *usrdata);
	static bool clbkRotRate(void *id, char *str, void *usrdata);

	double CalculateSunTrackingAngle();

	bool topRdyStow, bottomRdyStow;
	

	//ANIMATION HANDLES
	ANIMATIONCOMPONENT_HANDLE bottomAssembly0;
	ANIMATIONCOMPONENT_HANDLE bottomAssembly2;
	ANIMATIONCOMPONENT_HANDLE bottomAssembly3;
	ANIMATIONCOMPONENT_HANDLE bottomAssembly4;
	ANIMATIONCOMPONENT_HANDLE topAssembly10;
	ANIMATIONCOMPONENT_HANDLE topAssembly12;
	ANIMATIONCOMPONENT_HANDLE topAssembly13;
	ANIMATIONCOMPONENT_HANDLE topAssembly14;

	ANIMATIONCOMPONENT_HANDLE radiator20;
	ANIMATIONCOMPONENT_HANDLE radiator21;
	ANIMATIONCOMPONENT_HANDLE radiator22;
	ANIMATIONCOMPONENT_HANDLE radiator23;
	ANIMATIONCOMPONENT_HANDLE radiator24;
	ANIMATIONCOMPONENT_HANDLE radiator25;
	ANIMATIONCOMPONENT_HANDLE radiator26;
	ANIMATIONCOMPONENT_HANDLE radiator28;
	ANIMATIONCOMPONENT_HANDLE radiator29;
	ANIMATIONCOMPONENT_HANDLE radiator30;
	ANIMATIONCOMPONENT_HANDLE radiator31;
	ANIMATIONCOMPONENT_HANDLE radiator32;
	ANIMATIONCOMPONENT_HANDLE radiator33;
	ANIMATIONCOMPONENT_HANDLE radiator34;





	//bottom assembly
	MGROUP_ROTATE *rotBottomAssembly[5];
	MGROUP_TRANSLATE *transBottomAssembly;
	MGROUP_SCALE *scaleBottomAssembly[3];
	AnimState bottomAssembly;
	UINT animBottomAssembly;

	//bottom array rotation
	UINT animBottomArray;
	MGROUP_ROTATE *rotBottomArray;

	//top assembly
	AnimState topAssembly;
	UINT animTopAssembly;
	MGROUP_ROTATE *rotTopAssembly[5];
	MGROUP_TRANSLATE *transTopAssembly;
	MGROUP_SCALE *scaleTopAssembly[3];

	//top array rotation
	UINT animTopArray;
	MGROUP_ROTATE *rotTopArray;

	//radiator deploy
	AnimState radiator;
	UINT animRadiator;
	MGROUP_ROTATE *rotRad[16];

};